clear; close all; clc

rng(5);             % seed for reproducible "randomness"
%% 4b)
N = 30;
x = linspace(0,5,N)';
y = 3 * x + 4;              % true output
y = y + randn(N,1);         % add noise

% visualize
figure(1); clf; hold on
plot(x, y, 'ko', 'DisplayName','measurements no outliers')
legend('location', 'eastoutside')

%% 4c)
J = [x, ones(N,1)];
ab = (J' * J) \ (J' * y);                               % solve linear system
plot(x, ab(1) * x+ab(2) , 'b', 'DisplayName','L2 norm (no outliers)')

%% 4d)
% introduce outliers
y2      = y;
y2(1)   = 25;
y2(5)   = 30;
y2(end) = 10;
plot(x, y2, 'kx', 'DisplayName','measurements with outliers')

ab2 = (J'*J)\(J'*y2);                     % solve
plot(x, ab2(1) * x + ab2(2), 'r', 'DisplayName','L2 norm (outliers)')

%% TASK 5
% 5b)

f = [ 0; 0; ones(N,1) ];

A = [    J,     -eye(N) ; ...
        -J,     -eye(N) ];

b  = [ y ; -y ];        % without outliers
b2 = [ y2 ; -y2 ];      % with outliers

ab3 = linprog( f, A, b );
ab4 = linprog( f, A, b2 );

plot(x, ab3(1) * x + ab3(2), 'm', 'DisplayName','L1 norm (no outliers)')
plot(x, ab4(1) * x + ab4(2), 'c', 'DisplayName','L1 norm (outliers)')

%% 5c)
import casadi.*

opti = Opti();
ab_ca = opti.variable(2);           % parameters
s = opti.variable(N);               % slacks

opti.minimize(sum(s));
opti.subject_to( -s <= J * ab_ca - y <= s)
opti.solver('ipopt')
sol = opti.solve();
ab_ca_sol = sol.value(ab_ca);

plot(x, ab_ca_sol(1) * x + ab_ca_sol(2), 'y--', 'DisplayName','casadi L1 (no outliers)')

